Index: trunk/examples/objects/app-fermi/c/ex2/fermi.c
===================================================================
--- trunk/examples/objects/app-fermi/c/ex2/fermi.c	(revision 1659)
+++ trunk/examples/objects/app-fermi/c/ex2/fermi.c	(revision 3177)
@@ -1,15 +1,16 @@
-// ----------------------------------------------------------------------
-//  EXAMPLE: Fermi-Dirac function in C
-//
-//  This simple example shows how to use Rappture within a simulator
-//  written in C.
-// ======================================================================
-//  AUTHOR:  Derrick Kearney, Purdue University
-//  Copyright (c) 2005-2009  Purdue Research Foundation
-//
-//  See the file "license.terms" for information on usage and
-//  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
-// ======================================================================
-
+/*
+ * ----------------------------------------------------------------------
+ *  EXAMPLE: Fermi-Dirac function in C
+ *
+ *  This simple example shows how to use Rappture within a simulator
+ *  written in C.
+ * ======================================================================
+ *  AUTHOR:  Derrick Kearney, Purdue University
+ *  Copyright (c) 2004-2012  HUBzero Foundation, LLC
+ *
+ *  See the file "license.terms" for information on usage and
+ *  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+ * ======================================================================
+ */
 #include "rappture.h"
 
@@ -23,5 +24,5 @@
 int main(int argc, char * argv[]) {
 
-    // declare variables to interact with Rappture
+    /* declare variables to interact with Rappture */
     double T          = 0.0;
     double Ef         = 0.0;
@@ -30,5 +31,5 @@
 
 
-    // declare program variables
+    /* declare program variables */
     double E          = 0.0;
     double dE         = 0.0;
@@ -42,11 +43,11 @@
     double fArr[nPts];
 
-    // initialize the global interface
+    /* initialize the global interface */
     Rp_InterfaceInit(argc,argv,&fermi_io);
 
-    // check the global interface for errors
+    /* check the global interface for errors */
     if (Rp_InterfaceError() != 0) {
-        // there were errors while setting up the interface
-        // dump the traceback
+        /* there were errors while setting up the interface */
+        /* dump the traceback */
         Rp_Outcome *o = Rp_InterfaceOutcome();
         fprintf(stderr, "%s", Rp_OutcomeContext(o));
@@ -55,14 +56,16 @@
     }
 
-    // connect variables to the interface
-    // look in the global interface for an object named
-    // "temperature", convert its value to Kelvin, and
-    // store the value into the address of T.
-    // look in the global interface for an object named
-    // "Ef", convert its value to electron Volts and store
-    // the value into the address of Ef.
-    // look in the global interface for an object named
-    // factorsTable and set the variable result to
-    // point to it.
+    /*
+     * connect variables to the interface
+     * look in the global interface for an object named
+     * "temperature", convert its value to Kelvin, and
+     * store the value into the address of T.
+     * look in the global interface for an object named
+     * "Ef", convert its value to electron Volts and store
+     * the value into the address of Ef.
+     * look in the global interface for an object named
+     * factorsTable and set the variable result to
+     * point to it.
+     */
     Rp_InterfaceConnect("temperature",&T,"units=K",NULL);
     Rp_InterfaceConnect("Ef",&Ef,"units=eV",NULL);
@@ -70,8 +73,8 @@
     Rp_InterfaceConnect("fdfPlot2",p2,NULL);
 
-    // check the global interface for errors
+    /* check the global interface for errors */
     if (Rp_InterfaceError() != 0) {
-        // there were errors while retrieving input data values
-        // dump the traceback
+        /* there were errors while retrieving input data values */
+        /* dump the traceback */
         Rp_Outcome *o = Rp_InterfaceOutcome();
         fprintf(stderr, "%s", Rp_OutcomeContext(o));
@@ -80,5 +83,5 @@
     }
 
-    // do science calculations
+    /* do science calculations */
     kT = 8.61734e-5 * T;
     Emin = Ef - (10*kT);
@@ -96,15 +99,16 @@
     }
 
-    // set up the curves for the plot by using the add command
-    // Rp_PlotAdd(plot,name,nPts,xdata,ydata,fmt);
-    //
-    // to group curves on the same plot, just keep adding curves
-    // to save space, X array values are compared between curves.
-    // the the X arrays contain the same values, we only store
-    // one version in the internal data table, otherwise a new
-    // column is created for the array. for big arrays this may take
-    // some time, we should benchmark to see if this can be done
-    // efficiently.
-
+    /*
+     * set up the curves for the plot by using the add command
+     * Rp_PlotAdd(plot,name,nPts,xdata,ydata,fmt);
+     *
+     * to group curves on the same plot, just keep adding curves
+     * to save space, X array values are compared between curves.
+     * the the X arrays contain the same values, we only store
+     * one version in the internal data table, otherwise a new
+     * column is created for the array. for big arrays this may take
+     * some time, we should benchmark to see if this can be done
+     * efficiently.
+     */
     Rp_PlotAdd(p1,"fdfCurve1",nPts,fArr,EArr,"g:o");
 
@@ -112,8 +116,10 @@
     Rp_PlotAdd(p2,"fdfCurve3",nPts,fArr,EArr,"p--");
 
-    // close the global interface
-    // signal to the graphical user interface that science
-    // calculations are complete and to display the data
-    // as described in the views
+    /*
+     * close the global interface
+     * signal to the graphical user interface that science
+     * calculations are complete and to display the data
+     * as described in the views
+     */
     Rp_InterfaceClose();
 
Index: trunk/examples/objects/app-fermi/c/ex3/fermi.c
===================================================================
--- trunk/examples/objects/app-fermi/c/ex3/fermi.c	(revision 1659)
+++ trunk/examples/objects/app-fermi/c/ex3/fermi.c	(revision 3177)
@@ -1,15 +1,16 @@
-// ----------------------------------------------------------------------
-//  EXAMPLE: Fermi-Dirac function in C
-//
-//  This simple example shows how to use Rappture within a simulator
-//  written in C.
-// ======================================================================
-//  AUTHOR:  Derrick Kearney, Purdue University
-//  Copyright (c) 2005-2009  Purdue Research Foundation
-//
-//  See the file "license.terms" for information on usage and
-//  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
-// ======================================================================
-
+/*
+ * ----------------------------------------------------------------------
+ *  EXAMPLE: Fermi-Dirac function in C
+ *
+ *  This simple example shows how to use Rappture within a simulator
+ *  written in C.
+ * ======================================================================
+ *  AUTHOR:  Derrick Kearney, Purdue University
+ *  Copyright (c) 2004-2012  HUBzero Foundation, LLC
+ *
+ *  See the file "license.terms" for information on usage and
+ *  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+ * ======================================================================
+ */
 #include "rappture.h"
 
@@ -23,5 +24,5 @@
 int main(int argc, char * argv[]) {
 
-    // declare variables to interact with Rappture
+    /* declare variables to interact with Rappture */
     double T          = 0.0;
     double Ef         = 0.0;
@@ -32,5 +33,5 @@
 
 
-    // declare program variables
+    /* declare program variables */
     double E          = 0.0;
     double dE         = 0.0;
@@ -45,11 +46,11 @@
     double fArr2[nPts];
 
-    // initialize the global interface
+    /* initialize the global interface */
     Rp_InterfaceInit(argc,argv,&fermi_io);
 
-    // check the global interface for errors
+    /* check the global interface for errors */
     if (Rp_InterfaceError() != 0) {
-        // there were errors while setting up the interface
-        // dump the traceback
+        /* there were errors while setting up the interface */
+        /* dump the traceback */
         Rp_Outcome *o = Rp_InterfaceOutcome();
         fprintf(stderr, "%s", Rp_OutcomeContext(o));
@@ -58,13 +59,15 @@
     }
 
-    // connect variables to the interface
-    // look in the global interface for an object named
-    // "temperature", convert its value to Kelvin, and
-    // store the value into the address of T.
-    // look in the global interface for an object named
-    // "Ef", convert its value to electron Volts and store
-    // the value into the address of Ef.
-    // look in the global interface for the columns to
-    // store data. retrieve them for later use.
+    /*
+     * connect variables to the interface
+     * look in the global interface for an object named
+     * "temperature", convert its value to Kelvin, and
+     * store the value into the address of T.
+     * look in the global interface for an object named
+     * "Ef", convert its value to electron Volts and store
+     * the value into the address of Ef.
+     * look in the global interface for the columns to
+     * store data. retrieve them for later use.
+     */
     Rp_InterfaceConnect("temperature",&T,"units=K",NULL);
     Rp_InterfaceConnect("Ef",&Ef,"units=eV",NULL);
@@ -75,8 +78,8 @@
     Rp_InterfaceConnect("Energy * 2",y2,NULL);
 
-    // check the global interface for errors
+    /* check the global interface for errors */
     if (Rp_InterfaceError() != 0) {
-        // there were errors while retrieving input data values
-        // dump the traceback
+        /* there were errors while retrieving input data values */
+        /* dump the traceback */
         Rp_Outcome *o = Rp_InterfaceOutcome();
         fprintf(stderr, "%s", Rp_OutcomeContext(o));
@@ -85,5 +88,5 @@
     }
 
-    // do science calculations
+    /* do science calculations */
     kT = 8.61734e-5 * T;
     Emin = Ef - (10*kT);
@@ -103,9 +106,10 @@
     }
 
-    // store results in the results table
-    // add data to the table pointed to by the variable result.
-    // put the fArr data in the column named "Fermi-Dirac Factor"
-    // put the EArr data in the column named "Energy"
-    //
+    /*
+     * store results in the results table
+     * add data to the table pointed to by the variable result.
+     * put the fArr data in the column named "Fermi-Dirac Factor"
+     * put the EArr data in the column named "Energy"
+     */
     Rp_TableColumnStoreDouble(x1,nPts,fArr);
     Rp_TableColumnStoreDouble(y1,nPts,EArr);
@@ -113,8 +117,10 @@
     Rp_TableColumnStoreDouble(y2,nPts,EArr2);
 
-    // close the global interface
-    // signal to the graphical user interface that science
-    // calculations are complete and to display the data
-    // as described in the views
+    /*
+     * close the global interface
+     * signal to the graphical user interface that science
+     * calculations are complete and to display the data
+     * as described in the views
+     */
     Rp_InterfaceClose();
 
Index: trunk/examples/objects/app-fermi/c/fermi4.c
===================================================================
--- trunk/examples/objects/app-fermi/c/fermi4.c	(revision 1659)
+++ trunk/examples/objects/app-fermi/c/fermi4.c	(revision 3177)
@@ -1,15 +1,16 @@
-// ----------------------------------------------------------------------
-//  EXAMPLE: Fermi-Dirac function in C
-//
-//  This simple example shows how to use Rappture within a simulator
-//  written in C.
-// ======================================================================
-//  AUTHOR:  Derrick Kearney, Purdue University
-//  Copyright (c) 2005-2009  Purdue Research Foundation
-//
-//  See the file "license.terms" for information on usage and
-//  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
-// ======================================================================
-
+/*
+ * ----------------------------------------------------------------------
+ *  EXAMPLE: Fermi-Dirac function in C
+ *
+ *  This simple example shows how to use Rappture within a simulator
+ *  written in C.
+ * ======================================================================
+ *  AUTHOR:  Derrick Kearney, Purdue University
+ *  Copyright (c) 2004-2012  HUBzero Foundation, LLC
+ *
+ *  See the file "license.terms" for information on usage and
+ *  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+ * ======================================================================
+ */
 #include "rappture.h"
 
@@ -23,5 +24,5 @@
 int main(int argc, char * argv[]) {
 
-    // declare variables to interact with Rappture
+    /* declare variables to interact with Rappture */
     double T          = 0.0;
     double Ef         = 0.0;
@@ -29,5 +30,5 @@
 
 
-    // declare program variables
+    /* declare program variables */
     double E          = 0.0;
     double dE         = 0.0;
@@ -40,11 +41,11 @@
     double fArr[nPts];
 
-    // initialize the global interface
+    /* initialize the global interface */
     Rp_InterfaceInit(argc,argv,&fermi_io);
 
-    // check the global interface for errors
+    /* check the global interface for errors */
     if (Rp_InterfaceError() != 0) {
-        // there were errors while setting up the interface
-        // dump the traceback
+        /* there were errors while setting up the interface */
+        /* dump the traceback */
         Rp_Outcome *o = Rp_InterfaceOutcome();
         fprintf(stderr, "%s", Rp_OutcomeContext(o));
@@ -53,22 +54,24 @@
     }
 
-    // connect variables to the interface
-    // look in the global interface for an object named
-    // "temperature", convert its value to Kelvin, and
-    // store the value into the address of T.
-    // look in the global interface for an object named
-    // "Ef", convert its value to electron Volts and store
-    // the value into the address of Ef.
-    // look in the global interface for an object named
-    // factorsTable and set the variable result to
-    // point to it.
+    /*
+     * connect variables to the interface
+     * look in the global interface for an object named
+     * "temperature", convert its value to Kelvin, and
+     * store the value into the address of T.
+     * look in the global interface for an object named
+     * "Ef", convert its value to electron Volts and store
+     * the value into the address of Ef.
+     * look in the global interface for an object named
+     * factorsTable and set the variable result to
+     * point to it.
+     */
     Rp_InterfaceConnect("temperature",&T,"units=K",NULL);
     Rp_InterfaceConnect("Ef",&Ef,"units=eV",NULL);
     Rp_InterfaceConnect("factorsTable",result,NULL);
 
-    // check the global interface for errors
+    /* check the global interface for errors */
     if (Rp_InterfaceError() != 0) {
-        // there were errors while retrieving input data values
-        // dump the traceback
+        /* there were errors while retrieving input data values */
+        /* dump the traceback */
         Rp_Outcome *o = Rp_InterfaceOutcome();
         fprintf(stderr, "%s", Rp_OutcomeContext(o));
@@ -77,5 +80,5 @@
     }
 
-    // do science calculations
+    /* do science calculations */
     kT = 8.61734e-5 * T;
     Emin = Ef - (10*kT);
@@ -93,16 +96,19 @@
     }
 
-    // store results in the results table
-    // add data to the table pointed to by the variable result.
-    // put the fArr data in the column named "Fermi-Dirac Factor"
-    // put the EArr data in the column named "Energy"
-    //
+    /*
+     * store results in the results table
+     * add data to the table pointed to by the variable result.
+     * put the fArr data in the column named "Fermi-Dirac Factor"
+     * put the EArr data in the column named "Energy"
+     */
     Rp_TableAddData(result,"Fermi-Dirac Factor",nPts,fArr);
     Rp_TableAddData(result,"Energy",nPts,EArr);
 
-    // close the global interface
-    // signal to the graphical user interface that science
-    // calculations are complete and to display the data
-    // as described in the views
+    /*
+     * close the global interface
+     * signal to the graphical user interface that science
+     * calculations are complete and to display the data
+     * as described in the views
+     */
     Rp_InterfaceClose();
 
Index: trunk/examples/objects/app-fermi/cpp/fermi4.cc
===================================================================
--- trunk/examples/objects/app-fermi/cpp/fermi4.cc	(revision 1659)
+++ trunk/examples/objects/app-fermi/cpp/fermi4.cc	(revision 3177)
@@ -6,5 +6,5 @@
 // ======================================================================
 //  AUTHOR:  Derrick Kearney, Purdue University
-//  Copyright (c) 2005-2009  Purdue Research Foundation
+//  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 //
 //  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/fortran/fermi4.f
===================================================================
--- trunk/examples/objects/app-fermi/fortran/fermi4.f	(revision 1659)
+++ trunk/examples/objects/app-fermi/fortran/fermi4.f	(revision 3177)
@@ -8,5 +8,5 @@
 c  AUTHOR:  Michael McLennan, Purdue University
 c  AUTHOR:  Derrick Kearney, Purdue University
-c  Copyright (c) 2004-2008  Purdue Research Foundation
+c  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 c
 c  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/matlab/ex2/fermi.m
===================================================================
--- trunk/examples/objects/app-fermi/matlab/ex2/fermi.m	(revision 1659)
+++ trunk/examples/objects/app-fermi/matlab/ex2/fermi.m	(revision 3177)
@@ -7,5 +7,5 @@
 % ======================================================================
 %  AUTHOR:  Derrick Kearney, Purdue University
-%  Copyright (c) 2005-2009  Purdue Research Foundation
+%  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 %
 %  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/matlab/ex3/fermi.m
===================================================================
--- trunk/examples/objects/app-fermi/matlab/ex3/fermi.m	(revision 1659)
+++ trunk/examples/objects/app-fermi/matlab/ex3/fermi.m	(revision 3177)
@@ -7,5 +7,5 @@
 % ======================================================================
 %  AUTHOR:  Derrick Kearney, Purdue University
-%  Copyright (c) 2005-2009  Purdue Research Foundation
+%  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 %
 %  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/matlab/fermi4.m
===================================================================
--- trunk/examples/objects/app-fermi/matlab/fermi4.m	(revision 1659)
+++ trunk/examples/objects/app-fermi/matlab/fermi4.m	(revision 3177)
@@ -7,5 +7,5 @@
 % ======================================================================
 %  AUTHOR:  Derrick Kearney, Purdue University
-%  Copyright (c) 2005-2009  Purdue Research Foundation
+%  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 %
 %  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/octave/ex2/fermi.m
===================================================================
--- trunk/examples/objects/app-fermi/octave/ex2/fermi.m	(revision 1659)
+++ trunk/examples/objects/app-fermi/octave/ex2/fermi.m	(revision 3177)
@@ -7,5 +7,5 @@
 % ======================================================================
 %  AUTHOR:  Derrick Kearney, Purdue University
-%  Copyright (c) 2005-2009  Purdue Research Foundation
+%  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 %
 %  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/octave/ex3/fermi.m
===================================================================
--- trunk/examples/objects/app-fermi/octave/ex3/fermi.m	(revision 1659)
+++ trunk/examples/objects/app-fermi/octave/ex3/fermi.m	(revision 3177)
@@ -7,5 +7,5 @@
 % ======================================================================
 %  AUTHOR:  Derrick Kearney, Purdue University
-%  Copyright (c) 2005-2009  Purdue Research Foundation
+%  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 %
 %  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/python/ex2/fermi.py
===================================================================
--- trunk/examples/objects/app-fermi/python/ex2/fermi.py	(revision 1659)
+++ trunk/examples/objects/app-fermi/python/ex2/fermi.py	(revision 3177)
@@ -7,5 +7,5 @@
 # ======================================================================
 #  AUTHOR:  Derrick Kearney, Purdue University
-#  Copyright (c) 2005-2009  Purdue Research Foundation
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 #
 #  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/python/ex3/fermi.py
===================================================================
--- trunk/examples/objects/app-fermi/python/ex3/fermi.py	(revision 1659)
+++ trunk/examples/objects/app-fermi/python/ex3/fermi.py	(revision 3177)
@@ -7,5 +7,5 @@
 # ======================================================================
 #  AUTHOR:  Derrick Kearney, Purdue University
-#  Copyright (c) 2005-2009  Purdue Research Foundation
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 #
 #  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/python/fermi4.py
===================================================================
--- trunk/examples/objects/app-fermi/python/fermi4.py	(revision 1659)
+++ trunk/examples/objects/app-fermi/python/fermi4.py	(revision 3177)
@@ -7,5 +7,5 @@
 # ======================================================================
 #  AUTHOR:  Derrick Kearney, Purdue University
-#  Copyright (c) 2005-2009  Purdue Research Foundation
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 #
 #  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/tcl/ex2/fermi.tcl
===================================================================
--- trunk/examples/objects/app-fermi/tcl/ex2/fermi.tcl	(revision 1659)
+++ trunk/examples/objects/app-fermi/tcl/ex2/fermi.tcl	(revision 3177)
@@ -6,5 +6,5 @@
 # ======================================================================
 #  AUTHOR:  Derrick Kearney, Purdue University
-#  Copyright (c) 2005-2009  Purdue Research Foundation
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 #
 #  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/tcl/ex3/fermi.tcl
===================================================================
--- trunk/examples/objects/app-fermi/tcl/ex3/fermi.tcl	(revision 1659)
+++ trunk/examples/objects/app-fermi/tcl/ex3/fermi.tcl	(revision 3177)
@@ -6,5 +6,5 @@
 # ======================================================================
 #  AUTHOR:  Derrick Kearney, Purdue University
-#  Copyright (c) 2005-2009  Purdue Research Foundation
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 #
 #  See the file "license.terms" for information on usage and
Index: trunk/examples/objects/app-fermi/tcl/fermi4.tcl
===================================================================
--- trunk/examples/objects/app-fermi/tcl/fermi4.tcl	(revision 1659)
+++ trunk/examples/objects/app-fermi/tcl/fermi4.tcl	(revision 3177)
@@ -6,5 +6,5 @@
 # ======================================================================
 #  AUTHOR:  Derrick Kearney, Purdue University
-#  Copyright (c) 2005-2009  Purdue Research Foundation
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 #
 #  See the file "license.terms" for information on usage and