Index: branches/Rappture 1.2/gui/scripts/vtkisosurfaceviewer.tcl
===================================================================
--- branches/Rappture 1.2/gui/scripts/vtkisosurfaceviewer.tcl	(revision 3315)
+++ branches/Rappture 1.2/gui/scripts/vtkisosurfaceviewer.tcl	(revision 3316)
@@ -2100,5 +2100,5 @@
     $itk_component(xbutton) select
     itk_component add xposition {
-        ::scale $inner.xval -from 100 -to 1 \
+        ::scale $inner.xval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
@@ -2129,5 +2129,5 @@
 
     itk_component add yposition {
-        ::scale $inner.yval -from 100 -to 1 \
+        ::scale $inner.yval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
@@ -2161,5 +2161,5 @@
 
     itk_component add zposition {
-        ::scale $inner.zval -from 100 -to 1 \
+        ::scale $inner.zval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
Index: branches/Rappture 1.2/gui/scripts/vtkstreamlinesviewer.tcl
===================================================================
--- branches/Rappture 1.2/gui/scripts/vtkstreamlinesviewer.tcl	(revision 3315)
+++ branches/Rappture 1.2/gui/scripts/vtkstreamlinesviewer.tcl	(revision 3316)
@@ -2306,5 +2306,5 @@
 
     itk_component add xCutScale {
-        ::scale $inner.xval -from 100 -to 1 \
+        ::scale $inner.xval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
@@ -2335,5 +2335,5 @@
 
     itk_component add yCutScale {
-        ::scale $inner.yval -from 100 -to 1 \
+        ::scale $inner.yval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
@@ -2364,5 +2364,5 @@
 
     itk_component add zCutScale {
-        ::scale $inner.zval -from 100 -to 1 \
+        ::scale $inner.zval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
Index: branches/Rappture 1.2/gui/scripts/vtkviewer.tcl
===================================================================
--- branches/Rappture 1.2/gui/scripts/vtkviewer.tcl	(revision 3315)
+++ branches/Rappture 1.2/gui/scripts/vtkviewer.tcl	(revision 3316)
@@ -2102,5 +2102,5 @@
 
     itk_component add xCutScale {
-        ::scale $inner.xval -from 100 -to 1 \
+        ::scale $inner.xval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
@@ -2142,5 +2142,5 @@
 
     itk_component add yCutScale {
-        ::scale $inner.yval -from 100 -to 1 \
+        ::scale $inner.yval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
@@ -2182,5 +2182,5 @@
 
     itk_component add zCutScale {
-        ::scale $inner.zval -from 100 -to 1 \
+        ::scale $inner.zval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
Index: branches/Rappture 1.2/gui/scripts/vtkvolumeviewer.tcl
===================================================================
--- branches/Rappture 1.2/gui/scripts/vtkvolumeviewer.tcl	(revision 3315)
+++ branches/Rappture 1.2/gui/scripts/vtkvolumeviewer.tcl	(revision 3316)
@@ -2171,5 +2171,5 @@
 
     itk_component add xCutScale {
-        ::scale $inner.xval -from 100 -to 1 \
+        ::scale $inner.xval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
@@ -2198,5 +2198,5 @@
 
     itk_component add yCutScale {
-        ::scale $inner.yval -from 100 -to 1 \
+        ::scale $inner.yval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
@@ -2225,5 +2225,5 @@
 
     itk_component add zCutScale {
-        ::scale $inner.zval -from 100 -to 1 \
+        ::scale $inner.zval -from 100 -to 0 \
             -width 10 -orient vertical -showvalue yes \
             -borderwidth 1 -highlightthickness 0 \
Index: branches/Rappture 1.2/packages/vizservers/vtkvis/RpCutplane.cpp
===================================================================
--- branches/Rappture 1.2/packages/vizservers/vtkvis/RpCutplane.cpp	(revision 3315)
+++ branches/Rappture 1.2/packages/vizservers/vtkvis/RpCutplane.cpp	(revision 3316)
@@ -350,7 +350,34 @@
         if (_mapper[i] != NULL) {
             _borderMapper[i] = vtkSmartPointer<vtkPolyDataMapper>::New();
+#ifdef CUTPLANE_TIGHT_OUTLINE
             _outlineFilter[i] = vtkSmartPointer<vtkOutlineFilter>::New();
             _outlineFilter[i]->SetInputConnection(_mapper[i]->GetInputConnection(0, 0));
             _borderMapper[i]->SetInputConnection(_outlineFilter[i]->GetOutputPort());
+#else
+            _outlineSource[i] = vtkSmartPointer<vtkOutlineSource>::New();
+            switch (i) {
+            case 0:
+                _outlineSource[i]->SetBounds(bounds[0] + (bounds[1]-bounds[0])/2.,
+                                             bounds[0] + (bounds[1]-bounds[0])/2.,
+                                             bounds[2], bounds[3],
+                                             bounds[4], bounds[5]);
+                break;
+            case 1:
+                _outlineSource[i]->SetBounds(bounds[0], bounds[1],
+                                             bounds[2] + (bounds[3]-bounds[2])/2.,
+                                             bounds[2] + (bounds[3]-bounds[2])/2.,
+                                             bounds[4], bounds[5]);
+                break;
+            case 2:
+                _outlineSource[i]->SetBounds(bounds[0], bounds[1],
+                                             bounds[2], bounds[3],
+                                             bounds[4] + (bounds[5]-bounds[4])/2.,
+                                             bounds[4] + (bounds[5]-bounds[4])/2.);
+                break;
+            default:
+                ;
+            }
+            _borderMapper[i]->SetInputConnection(_outlineSource[i]->GetOutputPort());
+#endif
             _borderMapper[i]->SetResolveCoincidentTopologyToPolygonOffset();
         }
@@ -406,4 +433,10 @@
     double bounds[6];
     _dataSet->getBounds(bounds);
+#if 0
+    if (ratio == 0.0)
+        ratio = 0.001;
+    if (ratio == 1.0)
+        ratio = 0.999;
+#endif
     switch (axis) {
     case X_AXIS:
@@ -411,4 +444,10 @@
                                 0,
                                 0);
+#ifndef CUTPLANE_TIGHT_OUTLINE
+        _outlineSource[0]->SetBounds(bounds[0] + (bounds[1]-bounds[0]) * ratio,
+                                     bounds[0] + (bounds[1]-bounds[0]) * ratio,
+                                     bounds[2], bounds[3],
+                                     bounds[4], bounds[5]);
+#endif
         if (_mapper[0] != NULL)
             _mapper[0]->Update();
@@ -418,4 +457,10 @@
                                 bounds[2] + (bounds[3]-bounds[2]) * ratio,
                                 0);
+#ifndef CUTPLANE_TIGHT_OUTLINE
+        _outlineSource[1]->SetBounds(bounds[0], bounds[1],
+                                     bounds[2] + (bounds[3]-bounds[2]) * ratio,
+                                     bounds[2] + (bounds[3]-bounds[2]) * ratio,
+                                     bounds[4], bounds[5]);
+#endif
         if (_mapper[1] != NULL)
             _mapper[1]->Update();
@@ -425,4 +470,10 @@
                                 0,
                                 bounds[4] + (bounds[5]-bounds[4]) * ratio);
+#ifndef CUTPLANE_TIGHT_OUTLINE
+        _outlineSource[2]->SetBounds(bounds[0], bounds[1],
+                                     bounds[2], bounds[3],
+                                     bounds[4] + (bounds[5]-bounds[4]) * ratio,
+                                     bounds[4] + (bounds[5]-bounds[4]) * ratio);
+#endif
         if (_mapper[2] != NULL)
             _mapper[2]->Update();
Index: branches/Rappture 1.2/packages/vizservers/vtkvis/RpCutplane.h
===================================================================
--- branches/Rappture 1.2/packages/vizservers/vtkvis/RpCutplane.h	(revision 3315)
+++ branches/Rappture 1.2/packages/vizservers/vtkvis/RpCutplane.h	(revision 3316)
@@ -17,4 +17,5 @@
 #include <vtkPlane.h>
 #include <vtkOutlineFilter.h>
+#include <vtkOutlineSource.h>
 #include <vtkGaussianSplatter.h>
 
@@ -25,4 +26,6 @@
 namespace Rappture {
 namespace VtkVis {
+
+//#define CUTPLANE_TIGHT_OUTLINE
 
 /**
@@ -110,5 +113,9 @@
     vtkSmartPointer<vtkCutter> _cutter[3];
     vtkSmartPointer<vtkPlane> _cutPlane[3];
+#ifdef CUTPLANE_TIGHT_OUTLINE
     vtkSmartPointer<vtkOutlineFilter> _outlineFilter[3];
+#else
+    vtkSmartPointer<vtkOutlineSource> _outlineSource[3];
+#endif
     vtkSmartPointer<vtkGaussianSplatter> _splatter;
 };